SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/30/2012 20:44'!
newWithAmmount:aMeasure of:aUnit

	|distance|
	distance := Measure new.
	distance initializeWithAmmount: aMeasure  of: aUnit.
	^distance.! !

!Measure methodsFor: 'arithmetic' stamp: 'GrossodelSel 6/2/2012 19:29'!
* aMagnitude 
	| newUnit |
	
	( aMagnitude isKindOf: Measure )
		ifTrue:
			[ newUnit := unit * aMagnitude unit ]
		 ifFalse: 
			[ newUnit := unit ].
	
	^ Measure newWithAmmount: self asNumber * aMagnitude asNumber of: newUnit.! !

!Measure methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/30/2012 20:43'!
+ anotherDistance
	
	| anotherDistanceInTheSameUnit |
	
	anotherDistanceInTheSameUnit := anotherDistance convertTo: unit.
	^ Measure newWithAmmount: anotherDistanceInTheSameUnit amount + amount  of: unit.! !

!Measure methodsFor: 'arithmetic' stamp: 'GrossodelSel 5/30/2012 19:38'!
- anotherDistance
	
	^ self + anotherDistance negated.! !

!Measure methodsFor: 'arithmetic' stamp: 'GrossodelSel 6/2/2012 19:43'!
/ aNumberOrMeasure 

	^ self * aNumberOrMeasure reciprocal.
! !

!Measure methodsFor: 'comparing' stamp: 'GrossodelSel 5/30/2012 19:39'!
< aDistance 
	
	^ amount < ((aDistance convertTo: unit) amount).! !

!Measure methodsFor: 'comparing' stamp: 'GrossodelSel 6/1/2012 22:00'!
= anotherObject
	
	| areNothing asd selfAmountInBase anotherObjectAmountInBase |
	
	(self class = anotherObject class)
		ifFalse: [^ false].
	
	selfAmountInBase := unit convertToBaseUnitAmount: amount.
	anotherObjectAmountInBase := anotherObject unit convertToBaseUnitAmount: (anotherObject amount).
	areNothing := selfAmountInBase = anotherObjectAmountInBase and: [selfAmountInBase = 0].
	
	^ areNothing or: [ unit kindOfUnit = anotherObject unit kindOfUnit and: [ selfAmountInBase = anotherObjectAmountInBase ]].! !

!Measure methodsFor: 'converting' stamp: 'GrossodelSel 6/2/2012 19:10'!
adaptToNumber: receiverNumber andSend: selector

	^ Measure newWithAmmount: ( receiverNumber perform: selector with: amount ) of: unit.! !

!Measure methodsFor: 'accessing' stamp: 'GrossodelSel 5/30/2012 19:38'!
amount

	^ amount! !

!Measure methodsFor: 'converting' stamp: 'GrossodelSel 6/2/2012 19:08'!
asNumber

	^ amount.! !

!Measure methodsFor: 'error handling' stamp: 'GrossodelSel 6/2/2012 16:03'!
canNotConvertMeasurementException
	
	self error: 'No se puede convertir a una unidad de otro tipo de medida'.! !

!Measure methodsFor: 'converting' stamp: 'GrossodelSel 6/1/2012 22:00'!
convertTo:aUnit

	|newRepresentationOfTheSameDistance|
	
	(aUnit kindOfUnit = unit kindOfUnit)
		ifFalse: [self canNotConvertMeasurementException].
	
	newRepresentationOfTheSameDistance := Measure newWithAmmount: (unit convertAmount: amount to: aUnit) of: aUnit.
	^newRepresentationOfTheSameDistance.! !

!Measure methodsFor: 'comparing' stamp: 'GrossodelSel 6/1/2012 21:21'!
hash

	 ^ (unit convertToBaseUnitAmount: amount) hash.! !

!Measure methodsFor: 'initializing' stamp: 'GrossodelSel 5/30/2012 19:38'!
initializeWithAmmount:anAmmount of:aUnit

	amount := anAmmount.
	unit := aUnit.
	
	^ self.! !

!Measure methodsFor: 'testing' stamp: 'GrossodelSel 6/2/2012 19:37'!
isZero

	^ (unit convertToBaseUnitAmount: amount) isZero.! !

!Measure methodsFor: 'converting' stamp: 'GrossodelSel 5/30/2012 20:44'!
negated

	^ Measure newWithAmmount: -1 * amount  of: unit.! !

!Measure methodsFor: 'printing' stamp: 'GrossodelSel 5/30/2012 19:39'!
printOn: aStream

	amount printOn: aStream.
	aStream nextPutAll: (' ', (unit unitNameForAmount: amount)).! !

!Measure methodsFor: 'arithmetic' stamp: 'GrossodelSel 6/2/2012 19:45'!
reciprocal

	^ Measure newWithAmmount: 1/amount of: unit reciprocal.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/30/2012 19:38'!
to: aDistance 

	^ IntervalOfDistances newFrom: self to: aDistance.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/30/2012 19:38'!
to: aDistance by: aStepDistance 
	
	^ IntervalOfDistances newFrom: self to: aDistance by: aStepDistance.! !

!Measure methodsFor: 'accessing' stamp: 'GrossodelSel 5/30/2012 19:39'!
unit

	^ unit! !

Object subclass: #BaseUnit
	instanceVariableNames: 'name toBaseUnit fromBaseUnit kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!BaseUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:30'!
newDistanceWithName: aName millimeterScale: anAmountOfMillimeters

	^ self newMeasureOfKind: 'distance' withName: aName conversorToBaseUnit: [ :anAmount | anAmount*anAmountOfMillimeters ] conversorFromBaseUnit: [ :anAmount | anAmount/anAmountOfMillimeters ].! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:30'!
newMeasureOfKind: aKind withName: aName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits

	| aNewUnit |
	
	aNewUnit := self new.
	aNewUnit initializeAKindOfUnit: aKind withName: aName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits.
	^ aNewUnit.! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:30'!
newTemperatureWithName: aName kelvinFactor: aFactor shift: aShift
	
	^ self newMeasureOfKind: 'temperature' withName: aName conversorToBaseUnit: [ :anAmount | (anAmount + aShift) * aFactor ] conversorFromBaseUnit: [ :anAmount | anAmount / aFactor - aShift ].! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:30'!
newTimeWithName: aName secondsScale: aSecondsScale
	
	^ self newMeasureOfKind: 'time' withName: aName conversorToBaseUnit: [ :anAmount | anAmount * aSecondsScale ] conversorFromBaseUnit: [ :anAmount | anAmount / aSecondsScale ].! !

!BaseUnit methodsFor: 'comparing' stamp: 'GrossodelSel 6/2/2012 21:25'!
= anotherUnit

	 ^ (kind = anotherUnit kindOfUnit) and: [name = anotherUnit privateName].! !

!BaseUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/1/2012 19:19'!
convertAmount: anAmount to: aUnit 

	^ aUnit convertFromBaseUnitAmount: (self convertToBaseUnitAmount: anAmount).! !

!BaseUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/1/2012 19:11'!
convertFromBaseUnitAmount: anAmount

	^ fromBaseUnit value: anAmount.! !

!BaseUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/1/2012 19:10'!
convertToBaseUnitAmount: anAmount

	^ toBaseUnit value: anAmount.! !

!BaseUnit methodsFor: 'comparing' stamp: 'GrossodelSel 6/2/2012 21:26'!
hash

	 ^ (kind, name) hash.! !

!BaseUnit methodsFor: 'initializing' stamp: 'GrossodelSel 6/1/2012 19:59'!
initializeAKindOfUnit: aKind withName: aUnitName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits
	
	kind := aKind.
	toBaseUnit  := aBlockToConvertToBaseUnits.
	fromBaseUnit  := aBlockToConvertFromBaseUnits.
	name := aUnitName.! !

!BaseUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/1/2012 22:00'!
kindOfUnit

	^ kind! !

!BaseUnit methodsFor: 'printing' stamp: 'GrossodelSel 5/30/2012 19:33'!
printOn: aStream
	
	aStream nextPutAll: name.! !

!BaseUnit methodsFor: 'accessing' stamp: 'GrossodelSel 5/30/2012 21:23'!
privateFromBaseUnit

	^ fromBaseUnit! !

!BaseUnit methodsFor: 'accessing' stamp: 'GrossodelSel 5/30/2012 19:33'!
privateName

	^ name.! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/1/2012 20:22'!
unitNameForAmount: anAmmount
	
	| aUnitForAmmount |
	aUnitForAmmount := name.
	(anAmmount = 1 or: [name last = $s]) ifFalse: [ aUnitForAmmount := aUnitForAmmount , 's'].
	^ aUnitForAmmount.
! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'baseUnitNumerator baseUnitDenominator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureUnit class methodsFor: 'temperature' stamp: 'GrossodelSel 6/2/2012 20:29'!
celsius
	
	^ self newTemperatureWithName: 'celsius' kelvinFactor: 1 shift: 273.15.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
centimeter

	^ self newDistanceWithName: 'centimeter' millimeterScale: 10.
	! !

!MeasureUnit class methodsFor: 'time' stamp: 'GrossodelSel 6/2/2012 20:29'!
day
	
	^ self newTimeWithName: 'day' secondsScale: 24*60*60.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
decameter

	^ self newDistanceWithName: 'decameter' millimeterScale: 10000.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
decimeter
	
	^ self newDistanceWithName: 'decimeter' millimeterScale: 100.! !

!MeasureUnit class methodsFor: 'temperature' stamp: 'GrossodelSel 6/2/2012 20:29'!
fahrenheit 
	
	^ self newTemperatureWithName: 'fahrenheit' kelvinFactor: 5/9 shift: ((0 + 273.15) * 9 / 5 - 32).! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
hectometer

	^ self newDistanceWithName: 'hectometer' millimeterScale: 100000.! !

!MeasureUnit class methodsFor: 'time' stamp: 'GrossodelSel 6/2/2012 20:29'!
hour
	
	^ self newTimeWithName: 'hour' secondsScale: 60*60! !

!MeasureUnit class methodsFor: 'temperature' stamp: 'GrossodelSel 6/2/2012 20:29'!
kelvin 
	
	^ self newTemperatureWithName: 'kelvin' kelvinFactor: 1 shift: 0.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
kilometer
	
	^ self newDistanceWithName: 'kilometer' millimeterScale: 1000000.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
meter
	
	^ self newDistanceWithName: 'meter' millimeterScale: 1000.! !

!MeasureUnit class methodsFor: 'distance' stamp: 'GrossodelSel 6/2/2012 20:29'!
millimeter
	
	^ self newDistanceWithName: 'millimeter' millimeterScale: 1.! !

!MeasureUnit class methodsFor: 'time' stamp: 'GrossodelSel 6/2/2012 20:29'!
minute
	
	^ self newTimeWithName: 'minute' secondsScale: 60.! !

!MeasureUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:18'!
newDistanceWithName: aName millimeterScale: anAmountOfMillimeters

	^ self newMeasureOfKind: 'distance' withName: aName conversorToBaseUnit: [ :anAmount | anAmount*anAmountOfMillimeters ] conversorFromBaseUnit: [ :anAmount | anAmount/anAmountOfMillimeters ].! !

!MeasureUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:29'!
newMeasureOfKind: aKind withName: aName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits

	| aNewUnit |
	
	aNewUnit := self new.
	aNewUnit initializeAKindOfUnit: aKind withName: aName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits.
	^ aNewUnit.! !

!MeasureUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:18'!
newTemperatureWithName: aName kelvinFactor: aFactor shift: aShift
	
	^ self newMeasureOfKind: 'temperature' withName: aName conversorToBaseUnit: [ :anAmount | (anAmount + aShift) * aFactor ] conversorFromBaseUnit: [ :anAmount | anAmount / aFactor - aShift ].! !

!MeasureUnit class methodsFor: 'instance creation' stamp: 'GrossodelSel 6/2/2012 20:18'!
newTimeWithName: aName secondsScale: aSecondsScale
	
	^ self newMeasureOfKind: 'time' withName: aName conversorToBaseUnit: [ :anAmount | anAmount * aSecondsScale ] conversorFromBaseUnit: [ :anAmount | anAmount / aSecondsScale ].! !

!MeasureUnit class methodsFor: 'time' stamp: 'GrossodelSel 6/2/2012 20:30'!
second
	
	^ self newTimeWithName: 'second' secondsScale: 1.! !

!MeasureUnit methodsFor: 'comparing' stamp: 'GrossodelSel 6/2/2012 21:38'!
* anotherUnit

	| repeated aNewMeasureUnit |
	
	aNewMeasureUnit := MeasureUnit new.
	aNewMeasureUnit privateBaseUnitNumerator addAll: anotherUnit privateBaseUnitNumerator.
	aNewMeasureUnit privateBaseUnitDenominator addAll: anotherUnit privateBaseUnitDenominator.
	
	repeated := aNewMeasureUnit privateBaseUnitNumerator intersection: aNewMeasureUnit privateBaseUnitDenominator.
	
	aNewMeasureUnit privateBaseUnitDenominator removeAll: repeated.
	aNewMeasureUnit privateBaseUnitNumerator removeAll: repeated.
	
	^ aNewMeasureUnit.! !

!MeasureUnit methodsFor: 'comparing' stamp: 'GrossodelSel 6/2/2012 21:01'!
= anotherUnit

	^ baseUnitDenominator = anotherUnit privateBaseUnitDenominator and: [ baseUnitNumerator = anotherUnit privateBaseUnitNumerator ].! !

!MeasureUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/2/2012 21:06'!
convertAmount: anAmount to: aUnit 
	
	^ aUnit convertFromBaseUnitAmount: (self convertToBaseUnitAmount: anAmount).! !

!MeasureUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/2/2012 21:28'!
convertFromBaseUnitAmount: anAmount
	
	| aPartialConvertion |
	
	aPartialConvertion := anAmount.
	baseUnitNumerator do: [ :aBaseUnit | aPartialConvertion := aBaseUnit convertFromBaseUnitAmount: aPartialConvertion ].
	
	"Evita la division por cero."
	aPartialConvertion isZero
		ifTrue: [ ^ aPartialConvertion ].
	
	aPartialConvertion := aPartialConvertion reciprocal.
	baseUnitDenominator do: [ :aBaseUnit | aPartialConvertion := aBaseUnit convertFromBaseUnitAmount: aPartialConvertion ].
	
	^ aPartialConvertion reciprocal.! !

!MeasureUnit methodsFor: 'converting' stamp: 'GrossodelSel 6/2/2012 21:29'!
convertToBaseUnitAmount: anAmount

	| aPartialConvertion |
	
	aPartialConvertion := anAmount.
	baseUnitNumerator do: [ :aBaseUnit | aPartialConvertion := aBaseUnit convertToBaseUnitAmount: aPartialConvertion ].
	
	"Evita la division por cero."
	aPartialConvertion isZero
		ifTrue: [ ^ aPartialConvertion ].
	
	aPartialConvertion := aPartialConvertion reciprocal.
	baseUnitDenominator do: [ :aBaseUnit | aPartialConvertion := aBaseUnit convertToBaseUnitAmount: aPartialConvertion ].
	
	^ aPartialConvertion reciprocal.! !

!MeasureUnit methodsFor: 'printing' stamp: 'GrossodelSel 6/2/2012 20:44'!
getStringForUnits: units
	
	^ String streamContents: [ :s | units asStringOn: s delimiter: '*' ]! !

!MeasureUnit methodsFor: 'initializing' stamp: 'GrossodelSel 6/2/2012 20:36'!
initialize
	
	baseUnitNumerator := Bag new.
	baseUnitDenominator := Bag new.! !

!MeasureUnit methodsFor: 'initializing' stamp: 'GrossodelSel 6/2/2012 20:28'!
initializeAKindOfUnit: aKind withName: aUnitName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits

	| aBaseUnit |
	
	aBaseUnit := BaseUnit newMeasureOfKind: aKind withName: aUnitName conversorToBaseUnit: aBlockToConvertToBaseUnits conversorFromBaseUnit: aBlockToConvertFromBaseUnits.
	
	baseUnitNumerator add: aBaseUnit.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/2/2012 21:17'!
kindOfUnit

	| kindOfUnits denominatorKindOfUnits |
	
	kindOfUnits := self getStringForUnits: (baseUnitNumerator collect: [ :baseUnit | baseUnit kindOfUnit ]).
	denominatorKindOfUnits := self getStringForUnits: (baseUnitDenominator collect: [ :baseUnit | baseUnit kindOfUnit ]).
	
	kindOfUnits ifEmpty: 
		[ kindOfUnits = '1'  ].
	
	denominatorKindOfUnits ifNotEmpty: 
		[ kindOfUnits = '(', kindOfUnits, ') / (', denominatorKindOfUnits, ')'  ].
	
	^ kindOfUnits.! !

!MeasureUnit methodsFor: 'printing' stamp: 'GrossodelSel 6/2/2012 21:12'!
printOn: aStream
	
	aStream nextPutAll: self privateName.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/2/2012 21:02'!
privateBaseUnitDenominator

	^ baseUnitDenominator.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/2/2012 21:02'!
privateBaseUnitNumerator

	^ baseUnitNumerator.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/2/2012 21:17'!
privateName

	| kindOfUnits denominatorKindOfUnits |
	
	kindOfUnits := self getStringForUnits: (baseUnitNumerator collect: [ :baseUnit | baseUnit privateName ]).
	denominatorKindOfUnits := self getStringForUnits: (baseUnitDenominator collect: [ :baseUnit | baseUnit privateName ]).
	
	kindOfUnits ifEmpty: 
		[ kindOfUnits = '1'  ].
	
	denominatorKindOfUnits ifNotEmpty: 
		[ kindOfUnits = '(', kindOfUnits, ') / (', denominatorKindOfUnits, ')'  ].
	
	^ kindOfUnits.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'GrossodelSel 6/2/2012 20:59'!
stringForBaseUnitsAttribute: attributeSelector

	| kindOfUnits denominatorKindOfUnits |
	
	kindOfUnits := self getStringForUnits: (baseUnitNumerator collect: [ :baseUnit | baseUnit perform: #attributeSelector ]).
	denominatorKindOfUnits := self getStringForUnits: (baseUnitDenominator collect: [ :baseUnit | baseUnit perform: #attributeSelector ]).
	
	kindOfUnits ifEmpty: 
		[ kindOfUnits = '1'  ].
	
	denominatorKindOfUnits ifNotEmpty: 
		[ kindOfUnits = '(', kindOfUnits, ') / (', denominatorKindOfUnits, ')'  ].
	
	^ kindOfUnits.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/2/2012 21:13'!
unitNameForAmount: anAmmount
	
	| aUnitForAmmount |
	aUnitForAmmount := self privateName.
	(anAmmount = 1 or: [self privateName last = $s]) ifFalse: [ aUnitForAmmount := aUnitForAmmount , 's'].
	^ aUnitForAmmount.
! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'GrossodelSel 6/2/2012 16:01'!
canNotConvertMeasurementException
	
	^ Error.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GrossodelSel 6/2/2012 21:14'!
celsius
	
	^ MeasureUnit celsius.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
centimeter
	
	^ MeasureUnit centimeter.! !

!MeasureTest methodsFor: 'compound units' stamp: 'GrossodelSel 6/2/2012 19:19'!
cubicMeter

	^ self cubicUnit: self meter.! !

!MeasureTest methodsFor: 'compound units' stamp: 'GrossodelSel 6/2/2012 19:18'!
cubicUnit: aUnit

	^ (self squaredUnit: aUnit) * aUnit.! !

!MeasureTest methodsFor: 'time units' stamp: 'GrossodelSel 6/2/2012 21:14'!
day
	
	^ MeasureUnit day.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
decameter
	
	^ MeasureUnit decameter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
decimeter
	
	^ MeasureUnit decimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
eightCubicMeters

	^ Measure newWithAmmount: 8 of: self cubicMeter.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GrossodelSel 6/2/2012 21:14'!
fahrenheit
	
	^ MeasureUnit fahrenheit.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:31'!
fourSquaredMeters

	^ Measure newWithAmmount: 4 of: self squaredMeter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
hectometer
	
	^ MeasureUnit hectometer.! !

!MeasureTest methodsFor: 'time units' stamp: 'GrossodelSel 6/2/2012 21:14'!
hour
	
	^ MeasureUnit hour.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GrossodelSel 6/2/2012 21:14'!
kelvin
	
	^ MeasureUnit kelvin.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
kilometer
	
	^ MeasureUnit kilometer.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
meter

	^ MeasureUnit meter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GrossodelSel 6/2/2012 21:14'!
millimeter
	
	^ MeasureUnit millimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:51'!
minusOneMeter 
	
	^Measure newWithAmmount: -1 of: self meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'GrossodelSel 6/2/2012 21:14'!
minute
	
	^ MeasureUnit minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GrossodelSel 5/30/2012 20:35'!
oneCelsius
	
	^ Measure newWithAmmount: 1 of: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:51'!
oneCentimeter
	
	^Measure newWithAmmount: 1 of: self centimeter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:38'!
oneDay
	
	^ Measure newWithAmmount: 1 of: self day.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:39'!
oneHour
	
	^ Measure newWithAmmount: 1 of: self hour.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:51'!
oneHundredCentimeters
	
	^ Measure newWithAmmount: 100 of: self centimeter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:51'!
oneMeter
	
	^ Measure newWithAmmount: 1 of: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
oneMeterPerSecond

	^ Measure newWithAmmount: 1 of: self meter / self second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:50'!
oneMinute
	
	^ Measure newWithAmmount: 1 of: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:39'!
oneSecond

	^ Measure newWithAmmount: 1 of: self second.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
oneSquaredMeter

	^ Measure newWithAmmount: 1 of: self squaredMeter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
oneSquaredSecond

	^ Measure newWithAmmount: 1 of: self squaredSecond.! !

!MeasureTest methodsFor: 'time units' stamp: 'GrossodelSel 6/2/2012 21:14'!
second
	
	^ MeasureUnit second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:39'!
sixtyMinutes
	
	^ Measure newWithAmmount: 60 of: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:39'!
sixtyOneSeconds
	
	^ Measure newWithAmmount: 61 of: self second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:40'!
sixtySeconds
	
	^ Measure newWithAmmount: 60 of: self second.! !

!MeasureTest methodsFor: 'compound units' stamp: 'GrossodelSel 6/2/2012 19:19'!
squaredMeter

	^ self squaredUnit: self meter.! !

!MeasureTest methodsFor: 'compound units' stamp: 'GrossodelSel 6/2/2012 19:19'!
squaredSecond

	^ self squaredUnit: self second.! !

!MeasureTest methodsFor: 'compound units' stamp: 'GrossodelSel 6/2/2012 19:17'!
squaredUnit: aUnit

	^ aUnit * aUnit.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'GrossodelSel 6/1/2012 19:49'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'GrossodelSel 6/1/2012 19:55'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GrossodelSel 5/30/2012 21:16'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GrossodelSel 5/30/2012 20:41'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GrossodelSel 6/2/2012 16:02'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GrossodelSel 6/1/2012 21:23'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: Error.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GrossodelSel 6/1/2012 21:23'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: Error.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GrossodelSel 5/30/2012 20:36'!
thirtyTwoFahrenheits
	
	^ Measure newWithAmmount: 32 of: self fahrenheit.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:40'!
twentyFourHours
	
	^ Measure newWithAmmount: 24 of: self hour.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GrossodelSel 5/30/2012 20:36'!
twoCelsius
	
	^ Measure newWithAmmount: 2 of: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:52'!
twoHundredCentimeters
	
	^ Measure newWithAmmount: 200 of: self centimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:52'!
twoMeters
	
	^ Measure newWithAmmount: 2 of: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
twoMetersBySecond

	^ Measure newWithAmmount: 2 of: self meter / self second.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
twoMetersPerSquaredSecond

	^ Measure newWithAmmount: 2 of: self meter / self squaredSecond.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GrossodelSel 6/2/2012 19:30'!
twoMetersTimesSecond

	^ Measure newWithAmmount: 2 of: self meter * self second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:40'!
twoSeconds
	
	^ Measure newWithAmmount: 2 of: self second.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GrossodelSel 5/30/2012 20:36'!
zeroCelsius
	
	^ Measure newWithAmmount: 0 of: self celsius.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GrossodelSel 5/30/2012 20:36'!
zeroKelvin
	
	^ Measure newWithAmmount: 0 of: self kelvin.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GrossodelSel 5/30/2012 19:52'!
zeroMeters

	^ Measure newWithAmmount: 0 of: self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GrossodelSel 5/30/2012 20:40'!
zeroSeconds
	
	^ Measure newWithAmmount: 0 of: self second.! !
